import { ELEMENTS_CLASS } from "../enums/elements-class-enum";
import { PointModel } from "../../components/point-component/models/point-model";
import { PointDrawer } from "../../components/point-component/drawers/point-drawer";

export class ParserOrchestrator {
  constructor(mapArr) {
    this.mapArr = mapArr;
    this.list = new Array();
  }
  orchestrate() {
    for (const i in this.mapArr) this.do(this.mapArr[i]);
    for (const i in this.list) this.draw(this.list[i]);
  }
  do(map) {
    let object;
    switch (map.get("type")) {
      case ELEMENTS_CLASS.CIRCUMFERENCE:
        break;
      case ELEMENTS_CLASS.INTERSECTION_POINT:
        break;
      case ELEMENTS_CLASS.POINT:
        object = PointModel.do(map, this.list);
        break;
      default:
        break;
    }
    this.list.push(object);
  }
  draw(object) {
    let drawer;
    if (object == undefined) return;
    switch (object.elementClass) {
      case ELEMENTS_CLASS.CIRCUMFERENCE:
        break;
      case ELEMENTS_CLASS.INTERSECTION_POINT:
        break;
      case ELEMENTS_CLASS.POINT:
        drawer = new PointDrawer();
        break;
      default:
        break;
    }
    drawer.draw({
      attrs: {
        genericObject: object
      }
    });
  }
}
